/****************************************************************
** This file contains the modifications to the GD library to
** make ellipses and thicknesses work properly. When these functions
** are provided properly in Tom Boutell's library, they may be
** emulated or made passthrough in this file.
**
** This file includes the implementation to keep all functions
** static. The last line includes gdex.c--don't change this
** without removing the "static" designation from all these
** functions.
****************************************************************/
static void gdImageOpenPolygonEx(gdImagePtr in, gdPoint *polypoints, int npoly, int color, int width);
static void gdImageLineEx(gdImagePtr in, int x0, int y0, int x1, int y1, int color, int width);
static void gdImageDashedLineEx(gdImagePtr in, int x0, int y0, int x1, int y1, int color, int width);
static void gdImageEllipseEx(gdImagePtr in, int xc, int yc, int w, int h, int color, int thick);
static void gdImageArcEx(gdImagePtr in, int xc, int yc, int w, int h, int s, int e, int color, int thick);
static void gdImagePolygonEx(gdImagePtr in, gdPoint *polypoints, int npoly, int color, int width);
static void gdImageRectangleEx(gdImagePtr in, int x1, int y1, int x2, int y2, int color, int width);
static void gdImageStringUpEx(gdImagePtr im, gdFontPtr f, int x, int y, unsigned char *s, int color, int formatflags);
static void gdImageStringEx(gdImagePtr im, gdFontPtr f, int x, int y, unsigned char *s, int color, int formatflags);

#include "gdex.c"

#include "gdfontg.c"
#include "gdfontl.c"
#include "gdfontmb.c"
#include "gdfonts.c"
#include "gdfontt.c"
