##############################################################################
#
#  			Copyright 2001 Michael I Schwartz.
#			      All Rights Reserved
#
#
#  System        : 
#  Module        : 
#  Object Name   : $RCSfile: gdtext.tcl $
#  Revision      : $Revision: 1.7 $
#  Date          : $Date: 2002/01/06 17:02:15 $
#  Author        : $Author: Michael_Schwartz $
#  Created By    : Michael I Schwartz
#  Created       : Sun Nov 4 02:11:54 2001
#  Last Modified : <:11104.0225>
#
#  Description	
#
#  Notes
#
##############################################################################
#
#  Copyright (c) 2001 Michael I Schwartz.
# 
#  All Rights Reserved.
# 
#  This  document  may  not, in  whole  or in  part, be  copied,  photocopied,
#  reproduced,  translated,  or  reduced to any  electronic  medium or machine
#  readable form without prior written consent from Michael I Schwartz.
#
##############################################################################
package require gd

# This package tests text anchoring and justification

proc init { } {
    global gdtext
    global tk_version
    global Freetype_Font_Aliases
    
    set gdtext(font) "Arial 12"
    
    set gdtext(family) Arial
    set gdtext(size) 12
    set gdtext(weight) normal
    set gdtext(slant)  roman
    set gdtext(antialias) -antialias
    
    set gdtext(file) gdtext.jpg
    set gdtext(itext) "The true test\nof TrueType"
    set gdtext(debug) ""
    
    if [ catch {
        package require Img
    } err ] {
        set gdtext(display_image) 0
    } else {
        set gdtext(display_image) 1
    }
    
    # UI Initialization
    if { $tk_version < 8.0 } {
        error "Must run Tk 8.0 or newer for this demo"
    }
    # Destroy all subwindows
    if [ info exist gdtext(root) ] {
        eval destroy [ winfo ch $gdtext(root) ]
        unset gdtext(root)
        unset gdtext(canvas)
    }
    # Setup a menu
    menu .menu
    menu .menu.file
    menu .menu.format
    set gdtext(menu) .menu
    
    $gdtext(menu) add cascade -label File -menu $gdtext(menu).file -underline 0
    $gdtext(menu) add cascade -label Format -menu $gdtext(menu).format -underline 1
    
    global tcl_platform
    if { $tcl_platform(platform) == "windows" } {
      $gdtext(menu).file add command -label "Show Console" -command "console show"
    }
    $gdtext(menu).file add command -label Exit -command "exit 0"
    
    $gdtext(menu).format add command -label "Edit text..." -command EditText
    $gdtext(menu).format add separator
    $gdtext(menu).format add checkbutton -label Bold      -variable gdtext(weight)    -onvalue bold -offvalue normal -command redraw_all
    $gdtext(menu).format add checkbutton -label Italic    -variable gdtext(slant)     -onvalue italic -offvalue roman -command redraw_all
    $gdtext(menu).format add checkbutton -label Antialias -variable gdtext(antialias) -onvalue "-antialias" -offvalue "-noantialias" -command redraw_all
    $gdtext(menu).format add separator
    $gdtext(menu).format add command -label "Arial"   -font "Arial 12"       -command { set gdtext(family) Arial   ; redraw_all } 
    $gdtext(menu).format add command -label "Courier" -font "Courier 12"     -command { set gdtext(family) Courier ; redraw_all } 
    $gdtext(menu).format add command -label "Times"   -font "Times 12"       -command { set gdtext(family) Times   ; redraw_all } 
    $gdtext(menu).format add command -label "tiny"    -font "Courier 6"      -command { set gdtext(family) tiny    ; set gdtext(size) 6  ; redraw_all } 
    $gdtext(menu).format add command -label "small"   -font "Courier 7"      -command { set gdtext(family) small   ; set gdtext(size) 7  ; redraw_all }
    $gdtext(menu).format add command -label "medium"  -font "Courier 9 bold" -command { set gdtext(family) medium  ; set gdtext(size) 9  ; set gdtext(weight) bold ; redraw_all } 
    $gdtext(menu).format add command -label "large"   -font "Courier 10"     -command { set gdtext(family) large   ; set gdtext(size) 10 ; redraw_all } 
    $gdtext(menu).format add command -label "giant"   -font "Courier 12"     -command { set gdtext(family) giant   ; set gdtext(size) 12 ; redraw_all } 
    $gdtext(menu).format add separator
    $gdtext(menu).format add command -label 7     -command { set gdtext(size) 7  ; redraw_all } 
    $gdtext(menu).format add command -label 8     -command { set gdtext(size) 8  ; redraw_all }
    $gdtext(menu).format add command -label 9     -command { set gdtext(size) 9  ; redraw_all } 
    $gdtext(menu).format add command -label 10    -command { set gdtext(size) 10 ; redraw_all } 
    $gdtext(menu).format add command -label 11    -command { set gdtext(size) 11 ; redraw_all } 
    $gdtext(menu).format add command -label 12    -command { set gdtext(size) 12 ; redraw_all }
    $gdtext(menu).format add command -label 14    -command { set gdtext(size) 14 ; redraw_all } 
    $gdtext(menu).format add command -label 16    -command { set gdtext(size) 16 ; redraw_all } 
    $gdtext(menu).format add command -label 18    -command { set gdtext(size) 18 ; redraw_all } 

    set fn 0
    catch {
        set fn [ file exist fonts.alias ]
    } fn
    
    if { $fn == 0 } {
        global Freetype_Font_Aliases
        global tcl_platform
        global env
        
        catch {
            if { $tcl_platform(platform) == "windows" } {
                array set Freetype_Font_Aliases [ gd fontalias [ glob $env(windir)/fonts/*.ttf ] ]
            } elseif [ info exist env(GDFONTPATH) ] {
                array set Freetype_Font_Aliases [ gd fontalias [ glob $env(GDFONTPATH)/* ] ]
            }
        } err
    } else {
        source fonts.alias
    }
       
    if [ catch { package require BWidget } err ] {
        global Freetype_Font_Aliases
        $gdtext(menu).format add command -label "Other fonts..." -command set_alias_font
    } else {
        $gdtext(menu).format add command -label "Other fonts..." -command set_bwidget_font
    }
}

proc set_alias_font { } {
    # Need to list the fonts in a selection list, grab the selected one, and set gdtext(font) with it
    global gdtext
    global Freetype_Font_Aliases
    
    set gdtext(tweight) $gdtext(weight)
    set gdtext(tslant)  $gdtext(slant)
    
    if { [info exist gdtext(fontlist)] == 1 && [ winfo exists $gdtext(fontlist) ] == 1 } {
        raise $gdtext(fontlist)
        wm deiconify $gdtext(fontlist)
    } else {
        set gdtext(fontlist) [ toplevel .fontlist ]
        wm title $gdtext(fontlist) "Select Font"
        wm iconname $gdtext(fontlist) "Select Font"
        
        frame $gdtext(fontlist).top
        frame $gdtext(fontlist).buttons
        frame $gdtext(fontlist).top.fonts
        frame $gdtext(fontlist).top.sizes
        frame $gdtext(fontlist).top.style
        button $gdtext(fontlist).buttons.ok -text OK -command {
            set gdtext(family) [ $gdtext(fontlist).top.fonts.list get active ]
            set gdtext(size)   [ $gdtext(fontlist).top.sizes.list get active ]
            set gdtext(weight) $gdtext(tweight)
            set gdtext(slant)  $gdtext(tslant)
            wm withdraw $gdtext(fontlist)
            redraw_all
        }
        button $gdtext(fontlist).buttons.cancel -text Cancel -command {wm withdraw $gdtext(fontlist)}
        grid $gdtext(fontlist).buttons.ok -column 0 -row 0
        grid $gdtext(fontlist).buttons.cancel -column 1 -row 0
        
        pack $gdtext(fontlist).buttons -side bottom -fill x
        pack $gdtext(fontlist).top -side top -fill both -expand true
        pack $gdtext(fontlist).top.fonts -side left -fill both -expand true
        pack $gdtext(fontlist).top.sizes -side left -fill y
        pack $gdtext(fontlist).top.style -side left -fill y
        
        scrollbar $gdtext(fontlist).top.fonts.scroll -command "$gdtext(fontlist).top.fonts.list yview"
        listbox   $gdtext(fontlist).top.fonts.list   -yscroll "$gdtext(fontlist).top.fonts.scroll set" -setgrid 1 -height 12 -selectforeground gray
        
        pack $gdtext(fontlist).top.fonts.scroll -side right -fill y
        pack $gdtext(fontlist).top.fonts.list   -side left -expand true -fill both
        
        scrollbar $gdtext(fontlist).top.sizes.scroll -command "$gdtext(fontlist).top.sizes.list yview"
        listbox   $gdtext(fontlist).top.sizes.list   -yscroll "$gdtext(fontlist).top.sizes.scroll set" -setgrid 1 -height 12 -selectforeground gray
        
        pack $gdtext(fontlist).top.sizes.scroll -side right -fill y
        pack $gdtext(fontlist).top.sizes.list   -side left -expand true -fill both
        
        set gdtext(families) [ lsort [ font families ] ]
        eval $gdtext(fontlist).top.fonts.list insert 0 $gdtext(families)
        $gdtext(fontlist).top.sizes.list insert 0 6 7 8 9 10 11 12 14 16 18 20 22 24 28 32 36
        
        checkbutton $gdtext(fontlist).top.style.bold      -text Bold      -variable gdtext(tweight)   -onvalue bold   -offvalue normal
        checkbutton $gdtext(fontlist).top.style.italic    -text Italic    -variable gdtext(tslant)    -onvalue italic -offvalue roman
        pack $gdtext(fontlist).top.style.bold -side top -fill x
        pack $gdtext(fontlist).top.style.italic -side top -fill x
        
        $gdtext(fontlist).top.fonts.list see [ lsearch -exact $gdtext(families) $gdtext(family) ]
    }
}

proc init_profile_fonts { } {
    # Need to get the fonts in the ini file and store internally -- 20480 should be enough space....
    global gdtext
    global Freetype_Font_Aliases    
    set fontlist [ profile get -section "Freetype Font Aliases" -private gdfonts.ini -max 20480 ]
    foreach font $fontlist {
        set Freetype_Font_Aliases($font) [ profile get -section "Freetype Font Aliases" -private gdfonts.ini -key $font ]
    }
}

proc set_bwidget_font { } { 
    global gdtext
    set font [ SelectFont .font -font $gdtext(font) -sampletext $gdtext(itext)]
    
    P "Selected font $font"
    
    set gdtext(family) [ lindex $font 0 ]
    set gdtext(size)   [ lindex $font 1 ]
    set gdtext(weight) [ lindex $font 2 ]
    set gdtext(slant)  [ lindex $font 3 ]
    redraw_all
}


if { $tcl_interactive == 0 } {
  proc P { msg } { }
  proc PD {} {
      global gdtext
      proc P { msg } { puts $msg } 
      set gdtext(debug) "-debug" 
  }  
} else {
  proc P { msg } {
    puts $msg
    update idletasks
    after 100
  }
  set gdtext(debug) "-debug"
}

proc EditText { } {
    global gdtext
    if [ winfo exist .editframe ] {
        pack .editframe -side bottom -fill x -expand true
    } else {
        frame .editframe -height 16
        entry .editframe.text -width 20 -textvariable gdtext(itext)
        bind .editframe.text <Key-Return> { redraw_all }
        button .editframe.close -text Close -command "destroy .editframe"
        pack .editframe.close -side right -fill y -expand false
        button .editframe.redraw -text Redraw -command redraw_all
        pack .editframe.redraw -side right -fill y -expand false
        pack .editframe.text -fill both -expand true
        pack .editframe -side bottom -fill x -expand false
    }
}

proc redraw_all { } {
    global gdtext
    set gdtext(font) [ list $gdtext(family) $gdtext(size) ]
    if { $gdtext(weight) == "bold" } {
        set re "bold|demi|demibold|ultra|black"
        if { [ regexp -nocase $re $gdtext(font) ] == 0 } {
            lappend gdtext(font) bold
        }
    }
    if { $gdtext(slant) == "italic" } {
        set re "italic|oblique|slant"
        if { [ regexp -nocase $re $gdtext(font) ] == 0 } {
            lappend gdtext(font) italic
        }
    }
    build_canvas $gdtext(root)
    build_image_file $gdtext(file) 
    display_image $gdtext(file) 
}

proc build_image_file { filename } {
    global gdtext
    global Freetype_Font_Aliases
    
    set font $gdtext(font)
    
    # If this is windows, and if the font is not tiny, small, medium, large, or giant,
    # try to use the windows mapper to get the font name
    if [ info exist Freetype_Font_Aliases ] {
        set fn [ lindex $font 0 ]
        if [ info exist Freetype_Font_Aliases($fn) ] {
            set font [lreplace $font 0 0 $fn]
        }
        P "Matched $gdtext(font) to $font"
    } elseif [ catch { package require registry } err ] {
        P "No registry package"
    } else {
        switch -glob $font {
            tiny {P tiny}
            small {P small}
            medium {P medium}
            large {P large}
            giant {P giant}
            Arial {}
            Helvetica {}
            Times {}
            "Times New Roman" {}
            *.ttf {P ttf}
            *     {
                if [ catch {
                    set tryfont "[lindex $font 0] (TrueType)"
                    set fn [ registry get "HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Fonts" $tryfont ] 
                } err ] {
                    if [ catch {
                        set tryfont "[lindex $font 0] Normal (TrueType)"
                        set fn [ registry get "HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Fonts" $tryfont ] 
                    } err ] {
                        if [ catch {
                            set tryfont "[lindex $font 0] Roman (TrueType)"
                            set fn [ registry get "HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Fonts" $tryfont ] 
                        } err ] {
                            P "Can't get truetype font for $font: $err"
                        } else {
                            set len [ string length $fn ]
                            set fn [ string range $fn 0 [expr $len - 5 ] ]
                            set font [lreplace $font 0 0 $fn]
                        }
                    } else {
                        set len [ string length $fn ]
                        set fn [ string range $fn 0 [expr $len - 5 ] ]
                        set font [lreplace $font 0 0 $fn]
                    }
                } else {
                    set len [ string length $fn ]
                    set fn [ string range $fn 0 [expr $len - 5 ] ]
                    set font [lreplace $font 0 0 $fn]
                }
            }
        }
        P "Matched $gdtext(font) to $font"
    }
    
    P "Building text on an image"
    set im [ gd open -width 800 -height 1200 -background "0 0 0" ]
    
    if [ info exist Freetype_Font_Aliases ] {
        gd config $im -fonttable Freetype_Font_Aliases
    }
    
    P "Putting on a border and comment"
    gd rectangle $im 1 1 798 1198 -outline "255 104 255"
    gd text $im 600 10 -anchor nw -justify left -width 200 -font "Arial 14" -text "GD Image Text"  -fill "255 255 255"
    
    gd text $im 20 10  -anchor nw -justify left -font "Arial 12 bold"  -text "Anchoring text"   -fill "255 255 255"
    gd text $im 20 550 -anchor nw -justify left -font "Arial 12 bold"  -text "Justifying text"  -fill "255 255 255"
    
    P "Putting up a grid and text on the grid"
    set j right
    foreach triple { "150 150 nw" "400 150 n"      "650 150 ne" 
        "150 300 w"  "400 300 center" "650 300 e" 
        "150 450 sw" "400 450 s"      "650 450 se" } {
        # Put up a marker
        set x [ lindex $triple 0 ]
        set y [ lindex $triple 1 ]
        set a [ lindex $triple 2 ]
        set radius 5
        gd oval $im [ expr $x - $radius ] [ expr $y - $radius ] [ expr $x + $radius ] [ expr $y + $radius ] -outline "25 25 255" -fill "25 255 25"
        gd line $im [ expr $x - $radius ] $y [ expr $x + $radius ] $y  -fill #000000
        gd line $im  $x [ expr $y - $radius ] $x [ expr $y + $radius ] -fill #000000
        
        gd oval $im [ expr $x - $radius ] [ expr 600 + $y - $radius ] [ expr $x + $radius ] [ expr 600 + $y + $radius ] -outline "25 25 255" -fill "25 255 25"
        gd line $im [ expr $x - $radius ] [ expr 600 + $y ] [ expr $x + $radius ] [ expr $y + 600 ] -fill #000000
        gd line $im  $x [ expr 600 + $y - $radius ] $x [ expr 600 + $y + $radius ] -fill #000000
        
        # Braces around the text...
        switch $a {
            nw { set hs 0 }  n      { set hs 60 }  ne { set hs 120 }
            w  { set hs 0 }  center { set hs 60 }  e  { set hs 120 }
            sw { set hs 0 }  s      { set hs 60 }  se { set hs 120 }
        }
        gd line $im [ expr $x - $hs - 1 ] [ expr $y - 20 ] [ expr $x - $hs - 1 ] [ expr $y + 20 ] -fill "255 192 255"
        gd line $im [ expr $x + 120 - $hs + 1 ] [ expr $y - 20 ] [ expr $x + 120 - $hs + 1 ] [ expr $y + 20 ] -fill "255 192 255"
        gd line $im [ expr $x - $hs ] [ expr $y ]  [ expr $x + 120 - $hs ] [ expr $y ] -fill "255 192 255"
        
        gd line $im [ expr $x - 61 ] [ expr 600 + $y - 20 ] [ expr $x - 61 ] [ expr 600 + $y + 20 ] -fill "255 192 255"
        gd line $im [ expr $x + 61 ] [ expr 600 + $y - 20 ] [ expr $x + 61 ] [ expr 600 + $y + 20 ] -fill "255 192 255"
        gd line $im [ expr $x - 60 ] [ expr 600 + $y ]  [ expr $x + 60 ] [ expr 600 + $y  ] -fill "255 192 255"
        
        # Now the text
        P [ gd text $im $x $y $gdtext(debug) -anchor $a -text "$gdtext(itext) $a $gdtext(font)" -width 120 -font $font -fill "255 255 255" $gdtext(antialias) ]
        
        if { $j == "left" } { set j "center" } elseif { $j == "center" } { set j "right" } elseif { $j == "right" } { set j "left" }
        P [ gd text $im  $x [ expr 600 + $y ] $gdtext(debug) -anchor center -justify $j -text "$gdtext(itext) $j $gdtext(font)" -width 120 -font $font -fill "255 255 255" $gdtext(antialias) ]
    }
    
    P "Writing the file"
    gd close $im -save -file $filename
}

proc build_canvas { root } {
    global gdtext
    
    set font $gdtext(font)
    switch $font {
        tiny        { set font "Courier 6" }
        small       { set font "Courier 7" }
        medium      { set font "Courier 9 bold" }
        large       { set font "Courier 10" }
        giant       { set font "Courier 12" }
    }
    
    set gdtext(root) $root
    
    if [ info exist gdtext(canvas) ] {
        $gdtext(canvas) delete all
    } else {
        frame $root -width 640 -height 480
        canvas $root.c -yscrollcommand [ list $root.sy set] -xscrollcommand [ list $root.sx set ] \
                  -scrollregion { 0.0 0.0 1600.0 1200.0 } -background black
        scrollbar $root.sx -orient horizontal -command [ list $root.c xview ]
        scrollbar $root.sy -orient vertical -command [ list $root.c yview ]
        
        pack $root.sx -side bottom -fill x
        pack $root.sy -side right -fill y
        
        pack $root.c -side left -fill both -expand true
        set gdtext(canvas) $root.c
    }
    
    $gdtext(canvas) create rectangle 1 1 798 1198 -outline #FF88FF 
    $gdtext(canvas) create text 600 10 -anchor nw -justify left -width 200 -font "Arial 14 bold" -text "Canvas Text"  -fill #FFFFFF
    $gdtext(canvas) create text 20 10  -anchor nw -justify left -font "Arial 12 bold"  -text "Anchoring text -- correct for Truetype only"  -fill #FFFFFF
    $gdtext(canvas) create text 20 550 -anchor nw -justify left -font "Arial 12 bold"  -text "Justifying text -- correct for Truetype only"  -fill #FFFFFF
    
    set j right
    foreach triple { "150 150 nw" "400 150 n"      "650 150 ne" 
        "150 300 w"  "400 300 center" "650 300 e" 
        "150 450 sw" "400 450 s"      "650 450 se" } {
        # Put up a marker
        set x [ lindex $triple 0 ]
        set y [ lindex $triple 1 ]
        set a [ lindex $triple 2 ]
        set radius 5
        $gdtext(canvas) create oval [ expr $x - $radius ] [ expr $y - $radius ] [ expr $x + $radius ] [ expr $y + $radius ] -outline #1919FF -fill "#19FF19"
        $gdtext(canvas) create line [ expr $x - $radius ] $y [ expr $x + $radius ] $y  -fill #000000
        $gdtext(canvas) create line  $x [ expr $y - $radius ] $x [ expr $y + $radius ] -fill #000000
        
        $gdtext(canvas) create oval [ expr $x - $radius ] [ expr 600 + $y - $radius ] [ expr $x + $radius ] [ expr 600 + $y + $radius ] -outline #1919FF -fill "#19FF19"
        $gdtext(canvas) create line [ expr $x - $radius ] [ expr 600 + $y ] [ expr $x + $radius ] [ expr $y + 600 ] -fill #000000
        $gdtext(canvas) create line  $x [ expr 600 + $y - $radius ] $x [ expr 600 + $y + $radius ] -fill #000000
        
        # Braces around the text...
        switch $a {
            nw { set hs 0 }  n      { set hs 60 }  ne { set hs 120 }
            w  { set hs 0 }  center { set hs 60 }  e  { set hs 120 }
            sw { set hs 0 }  s      { set hs 60 }  se { set hs 120 }
        }
        $gdtext(canvas) create line [ expr $x - $hs - 1 ] [ expr $y - 20 ] [ expr $x - $hs - 1 ] [ expr $y + 20 ] -fill #FFCFFF
        $gdtext(canvas) create line [ expr $x + 120 - $hs + 1 ] [ expr $y - 20 ] [ expr $x + 120 - $hs + 1 ] [ expr $y + 20 ] -fill #FFCFFF
        $gdtext(canvas) create line [ expr $x - $hs ] [ expr $y ]  [ expr $x + 120 - $hs ] [ expr $y ] -fill #FFCFFF
        
        $gdtext(canvas) create line [ expr $x - 61 ] [ expr 600 + $y - 20 ] [ expr $x - 61 ] [ expr 600 + $y + 20 ] -fill #FFCFFF
        $gdtext(canvas) create line [ expr $x + 61 ] [ expr 600 + $y - 20 ] [ expr $x + 61 ] [ expr 600 + $y + 20 ] -fill #FFCFFF
        $gdtext(canvas) create line [ expr $x - 60 ] [ expr 600 + $y ]  [ expr $x + 60 ] [ expr 600 + $y  ] -fill #FFCFFF
        
        # Now the text
        $gdtext(canvas) create text $x $y -anchor $a -text "$gdtext(itext) $a $gdtext(font)" -width 120 -font $font -fill #FFFFFF
        
        if { $j == "left" } { set j "center" } elseif { $j == "center" } { set j "right" } elseif { $j == "right" } { set j "left" }
        $gdtext(canvas) create text $x [ expr 600 + $y ] -anchor center -justify $j -text "$gdtext(itext) $j $gdtext(font)" -width 120 -font $font -fill #FFFFFF
    }    
    
}

proc display_image { filename } {
    global gdtext
    # Assumes the image is one that may be displayed (e.g., gif)
    if { $gdtext(display_image) != 0 } {
        if [ catch {
            set im [ image create photo -file $filename ]
            $gdtext(canvas) create image 800 0 -image $im -anchor nw
        } err ] {
            $gdtext(canvas) create text 800 0 -anchor nw -width 600 -justify left -text "Can't load image:\n$err" -fill #FFFFAA
        }
    } else {
        if [ catch { 
            exec cmd /c $gdtext(file) &
        } err ] {
            $gdtext(canvas) create text 800 0 -anchor nw -width 600 -justify left -text "Can't load image helper application:\n$err" -fill #FFFFAA
        }
    }
}

init
build_image_file $gdtext(file)
build_canvas .c
. configure -menu .menu

display_image $gdtext(file)

pack $gdtext(root) -fill both -expand true

#if { $tcl_interactive == 0 } { exit }
